package jaxrclient

import javax.xml.registry.*; 
import javax.xml.registry.infomodel.*; 
import java.net.*;
import java.util.*;
import java.util.regex.*;

public class UDDIQueryClient {
  Connection connection = null;
  public static void main(String[] args) {
    String queryURL = "http://uddi.ibm.com/ubr/inquiryapi";
    UDDIQueryClient queryClient = new UDDIQueryClient();
    queryClient.makeConnection(queryURL);
    queryClient.executeQuery(args[0]);
  }

// WXgɐڑs
  public void makeConnection(String queryUrl) {
    String httpProxyHost = "";
    String httpProxyPort = "";
    Properties props = new Properties();
    props.setProperty("javax.xml.registry.queryManagerURL", queryUrl);
    props.setProperty("com.sun.xml.registry.http.proxyHost", httpProxyHost);
    props.setProperty("com.sun.xml.registry.http.proxyPort", httpProxyPort);

    try {
      ConnectionFactory factory = 
        ConnectionFactory.newInstance();
      factory.setProperties(props);
      connection = factory.createConnection();
      System.out.println("WXgɐڑ܂D");
    } catch (Exception e) {
      e.printStackTrace();
      try {
        connection.close();
      } catch (Exception je) {}
    }
  }
  // WXgČʂ\
  public void executeQuery(String queryString) {
    try {
      // |WgT[rX̌
      RegistryService rs = connection.getRegistryService();
      BusinessQueryManager bqm = 
        rs.getBusinessQueryManager();
      System.out.println("WXgT[rX܂D");
      // Zbg
      Collection namePatterns = new ArrayList();
      namePatterns.add("%"+queryString+"%"); 

      System.out.println(queryString+"܂Concept܂D");
      BulkResponse br = bqm.findConcepts(null, namePatterns, 
        null, null, null);
      Collection specConcepts = br.getCollection();
      System.out.println(specConcepts.size()+"Concept܂D");
      Iterator iter = specConcepts.iterator();
      Pattern pattern = Pattern.compile("http://[^/]*\\.[^/]*/.*");
      // ʂ̕\
      while (iter.hasNext()) {
        Concept concept = (Concept) iter.next();
        String name = concept.getName().getValue();
        Collection links = concept.getExternalLinks();
        String wsdlURI = null;
        if (links.size() > 0) {
          ExternalLink link = 
            (ExternalLink) links.iterator().next();
          wsdlURI = link.getExternalURI();
        }else continue;
        Matcher matcher = pattern.matcher(wsdlURI);
        if (matcher==null||!matcher.matches()) continue;

        System.out.println("\nConcept:\n\tO: " + 
          name + "\n\tKey: " + 
          concept.getKey().getId() + "\n\t: " + 
          concept.getDescription().getValue());
          System.out.println("\tWSDLURL: '" + wsdlURI+"'");
        }
      }
    } catch (Exception e) {
      e.printStackTrace();
    } finally {
      try { connection.close(); } catch (Exception je) {}
    }
  }
}